/*
 * Tapioca Daemon
 * Copyright (c) 2005 INdT.
 * @author Andre Moreira Magalhaes <andre.magalhaes@indt.org.br>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __TAPIOCAD_CONFIG_H__
#define __TAPIOCAD_CONFIG_H__

#include <glib.h>

G_BEGIN_DECLS

typedef struct _TapiocadConfig        TapiocadConfig;
typedef struct _TapiocadConfigPrivate TapiocadConfigPrivate;

struct _TapiocadConfig 
{
    gchar *file;

    gchar *service_name;      /* dbus service name */              
    gchar **protocols;        /* supported protocols */

    TapiocadConfigPrivate *priv;
};

gboolean              tapiocad_config_init              (void);
void                  tapiocad_config_deinit            (void);
G_CONST_RETURN GList *tapiocad_config_get_list          (void);
TapiocadConfig       *tapiocad_config_get_from_protocol (const gchar *protocol);

G_END_DECLS

#endif
