/*
 * Tapiocad library
 * Copyright (C) 2005 INdT 
 * @author Andre Moreira Magalhaes <andre.magalhaes@indt.org.br>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __TAPIOCAD_CONNECTION_MANAGER_H__
#define __TAPIOCAD_CONNECTION_MANAGER_H__

#include <glib.h>
#include <glib-object.h>
#include <dbus/dbus-glib-bindings.h>

G_BEGIN_DECLS

#define TAPIOCAD_CONNECTION_MANAGER_TYPE              (tapiocad_connection_manager_get_type ())
#define TAPIOCAD_CONNECTION_MANAGER(object)           (G_TYPE_CHECK_INSTANCE_CAST ((object), TAPIOCAD_CONNECTION_MANAGER_TYPE, TapiocadConnectionManager))
#define TAPIOCAD_CONNECTION_MANAGER_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST ((klass), TAPIOCAD_CONNECTION_MANAGER_TYPE, TapiocadConnectionManagerClass))
#define IS_TAPIOCAD_CONNECTION_MANAGER(object)        (G_TYPE_CHECK_INSTANCE_TYPE ((object), TAPIOCAD_CONNECTION_MANAGER_TYPE))
#define IS_TAPIOCAD_CONNECTION_MANAGER_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), TAPIOCAD_CONNECTION_MANAGER_TYPE))
#define TAPIOCAD_CONNECTION_MANAGER_GET_CLASS(obj)    (G_TYPE_INSTANCE_GET_CLASS ((obj), TAPIOCAD_CONNECTION_MANAGER_TYPE, TapiocadConnectionManagerClass))
#define TAPIOCAD_CONNECTION_MANAGER_GET_PRIVATE(obj)  (G_TYPE_INSTANCE_GET_PRIVATE ((obj), TAPIOCAD_CONNECTION_MANAGER_TYPE, TapiocadConnectionManagerPrivate))

typedef struct _TapiocadConnectionManager        TapiocadConnectionManager;
typedef struct _TapiocadConnectionManagerClass   TapiocadConnectionManagerClass;
typedef struct _TapiocadConnectionManagerPrivate TapiocadConnectionManagerPrivate;

struct _TapiocadConnectionManagerClass
{
  GObjectClass parent;
};

struct _TapiocadConnectionManager
{
  GObject parent;

  TapiocadConnectionManagerPrivate *priv;
};

GType    tapiocad_connection_manager_get_type                (void);

gboolean tapiocad_connection_manager_has_service             (TapiocadConnectionManager *tcm,
                                                              const gchar *service);
void     tapiocad_connection_manager_remove_service          (TapiocadConnectionManager *tcm,
                                                              const gchar *service);
guint    tapiocad_connection_manager_get_service_count       (TapiocadConnectionManager *tcm);

/* dbus functions */
gboolean tapiocad_connection_manager_get_supported_protocols (TapiocadConnectionManager *tcm,
                                                              gchar ***protocols,
                                                              GError **error);
gboolean tapiocad_connection_manager_create_connection       (TapiocadConnectionManager *tcm,
                                                              const gchar *protocol, 
                                                              gchar **service_name,
                                                              gchar **object_path,
                                                              GError **error);

G_END_DECLS

#endif
